Index: binaries/data/mods/public/gui/common/functions_utility.js
===================================================================
--- binaries/data/mods/public/gui/common/functions_utility.js	(revision 17033)
+++ binaries/data/mods/public/gui/common/functions_utility.js	(working copy)
@@ -146,10 +146,17 @@
 	return ret;
 }
 
 // ====================================================================
 
+function sameColor(color1, color2)
+{
+    return color1.r === color2.r && color1.g === color2.g && color1.b === color2.b;
+}
+
+// ====================================================================
+
 /**
  * Convert time in milliseconds to [hh:]mm:ss string representation.
  * @param time Time period in milliseconds (integer)
  * @return String representing time period
  */
Index: binaries/data/mods/public/gui/gamesetup/gamesetup.js
===================================================================
--- binaries/data/mods/public/gui/gamesetup/gamesetup.js	(revision 17033)
+++ binaries/data/mods/public/gui/gamesetup/gamesetup.js	(working copy)
@@ -8,10 +8,13 @@
 const g_MapTypes = prepareForDropdown(g_Settings ? g_Settings.MapTypes : undefined);
 const g_PopulationCapacities = prepareForDropdown(g_Settings ? g_Settings.PopulationCapacities : undefined);
 const g_StartingResources = prepareForDropdown(g_Settings ? g_Settings.StartingResources : undefined);
 const g_VictoryConditions = prepareForDropdown(g_Settings ? g_Settings.VictoryConditions : undefined);
 
+// All colors except gaia
+const g_PlayerColors = initPlayerDefaults().slice(1).map(pData => pData.Color);
+
 ////////////////////////////////////////////////////////////////////////////////////////////////
 
 // Is this is a networked game, or offline
 var g_IsNetworked;
 
@@ -374,10 +377,17 @@
 				g_GameAttributes.settings.PlayerData[playerSlot].Team = this.selected - 1;
 
 			updateGameAttributes();
 		};
 
+		// Populate color drop-down lists.
+		var colorPicker = Engine.GetGUIObjectByName("playerColorPicker["+i+"]");
+		colorPicker.list = g_PlayerColors.map(color => '[color="' + color.r + ' ' + color.g + ' ' + color.b + '"] ■[/color]');
+		colorPicker.list_data = g_PlayerColors.map((color, index) => index);
+		colorPicker.selected = -1;
+		colorPicker.onSelectionChange = function() { selectPlayerColor(playerSlot, this.selected); };
+
 		// Set events
 		var civ = Engine.GetGUIObjectByName("playerCiv["+i+"]");
 		civ.onSelectionChange = function() {
 			if ((this.selected != -1)&&(g_GameAttributes.mapType !== "scenario"))
 				g_GameAttributes.settings.PlayerData[playerSlot].Civ = this.list_data[this.selected];
@@ -886,10 +896,46 @@
 	}
 
 	updateGameAttributes();
 }
 
+/**
+ *  Assigns the given color to that player.
+ */
+function selectPlayerColor(playerSlot, colorIndex)
+{
+	if (colorIndex == -1)
+		return;
+
+	var playerData = g_GameAttributes.settings.PlayerData;
+
+	// Add missing properties
+	playerData.forEach((pData, index) => {
+		if (!pData.Color)
+			pData.Color = g_PlayerColors[index];
+	});
+
+	// If someone else has that color, give that player the old color
+	var pData = playerData.find(pData => sameColor(g_PlayerColors[colorIndex], pData.Color));
+	if (pData)
+		pData.Color = playerData[playerSlot].Color;
+
+	// Assign the new color
+	playerData[playerSlot].Color = g_PlayerColors[colorIndex];
+
+	// Ensure colors are not used twice after increasing the number of players
+	for (let i = playerData.length - 1; i >= 0; --i)
+	{
+		// If someone else has that color, assign an unused color
+		if (playerData.some((pData, j) => i != j && sameColor(playerData[i].Color, pData.Color)))
+			playerData[i].Color = g_PlayerColors.find(color => playerData.every(pData => !sameColor(color, pData.Color)));
+	}
+
+	if (!g_IsInGuiUpdate)
+		updateGameAttributes();
+}
+
 // Called when the user selects a map type from the list
 function selectMapType(type)
 {
 	// Avoid recursion
 	if (g_IsInGuiUpdate)
@@ -1420,18 +1466,20 @@
 		var pCiv = Engine.GetGUIObjectByName("playerCiv["+i+"]");
 		var pCivText = Engine.GetGUIObjectByName("playerCivText["+i+"]");
 		var pTeam = Engine.GetGUIObjectByName("playerTeam["+i+"]");
 		var pTeamText = Engine.GetGUIObjectByName("playerTeamText["+i+"]");
 		var pColor = Engine.GetGUIObjectByName("playerColor["+i+"]");
+		var pColorPicker = Engine.GetGUIObjectByName("playerColorPicker["+i+"]");
+		var pColorPickerHeading = Engine.GetGUIObjectByName("playerColorHeading");
 
 		// Player data / defaults
 		var pData = mapSettings.PlayerData ? mapSettings.PlayerData[i] : {};
 		var pDefs = g_DefaultPlayerData ? g_DefaultPlayerData[i] : {};
 
 		// Common to all game types
-		var color = rgbToGuiColor(getSetting(pData, pDefs, "Color"));
-		pColor.sprite = "color:" + color + " 100";
+		var color = getSetting(pData, pDefs, "Color");
+		pColor.sprite = "color:" + rgbToGuiColor(color) + " 100";
 		pName.caption = translate(getSetting(pData, pDefs, "Name"));
 
 		var team = getSetting(pData, pDefs, "Team");
 		var civ = getSetting(pData, pDefs, "Civ");
 
@@ -1466,10 +1514,19 @@
 			pTeam.hidden = false;
 			// Set dropdown values
 			pCiv.selected = (civ ? pCiv.list_data.indexOf(civ) : 0);
 			pTeam.selected = (team !== undefined && team >= 0) ? team+1 : 0;
 		}
+
+		// Allow host to chose player colors random maps, since they don't define custom colors currently.
+		// TODO: Random maps might define custom colors too at some point. We should make sure that
+		// we remove colors that are too similar to others, so that players can't select seemingly identical colors.
+		const canChangeColors = g_IsController && g_GameAttributes.mapType == "random"
+		pColorPicker.hidden = !canChangeColors;
+		pColorPickerHeading.hidden = !canChangeColors;
+		if (canChangeColors)
+			pColorPicker.selected = g_PlayerColors.findIndex(col => sameColor(col, color));
 	}
 
 	Engine.GetGUIObjectByName("mapInfoDescription").caption = playerString;
 
 	g_IsInGuiUpdate = false;
Index: binaries/data/mods/public/gui/gamesetup/gamesetup.xml
===================================================================
--- binaries/data/mods/public/gui/gamesetup/gamesetup.xml	(revision 17033)
+++ binaries/data/mods/public/gui/gamesetup/gamesetup.xml	(working copy)
@@ -40,11 +40,14 @@
 			<object size="24 49 100%-440 345" type="image" sprite="ModernDarkBoxGold" name="playerAssignmentsPanel">
 				<object size="0 6 100% 30">
 					<object name="playerNameHeading" type="text" style="ModernLabelText" size="0 0 22% 100%">
 						<translatableAttribute id="caption">Player Name</translatableAttribute>
 					</object>
-					<object name="playerPlacementHeading" type="text" style="ModernLabelText" size="22%+5 0 50%+35 100%">
+					<object name="playerColorHeading" type="text" style="ModernLabelText" size="22%+5 0 22%+40 100%">
+						<translatableAttribute id="caption">Color</translatableAttribute>
+					</object>
+					<object name="playerPlacementHeading" type="text" style="ModernLabelText" size="22%+45 0 50%+35 100%">
 						<translatableAttribute id="caption">Player Placement</translatableAttribute>
 					</object>
 					<object name="playerCivHeading" type="text" style="ModernLabelText" size="50%+65 0 85%-26 100%">
 						<translatableAttribute id="caption">Civilization</translatableAttribute>
 					</object>
@@ -67,11 +70,14 @@
 				<object size="1 36 100%-1 100%">
 					<repeat count="8">
 						<object name="playerBox[n]" size="0 0 100% 32" hidden="true">
 							<object name="playerColor[n]" type="image" size="0 0 100% 100%"/>
 							<object name="playerName[n]" type="text" style="ModernLabelText" size="0 2 22% 30"/>
-							<object name="playerAssignment[n]" type="dropdown" style="ModernDropDown" size="22%+5 2 50%+35 30" tooltip_style="onscreenToolTip">
+							<object name="playerColorPicker[n]" type="dropdown" style="ModernDropDown" size="22%+5 2 22%+33 30" sprite="" scrollbar="false" button_width="22" font="sans-stroke-14" tooltip_style="onscreenToolTip">
+								<translatableAttribute id="tooltip">Pick a color.</translatableAttribute>
+							</object>
+							<object name="playerAssignment[n]" type="dropdown" style="ModernDropDown" size="22%+37 2 50%+35 30" tooltip_style="onscreenToolTip">
 								<translatableAttribute id="tooltip">Select player.</translatableAttribute>
 							</object>
 							<object name="playerAssignmentText[n]" type="text" style="ModernLabelText" size="22%+5 0 50%+35 30"/>
 							<object name="playerConfig[n]" type="button" style="StoneButton" size="50%+40 4 50%+64 28"
 								tooltip_style="onscreenToolTip"